
/* 
    KWinTV dimensions

    Copyright (C) 2001 George Staikos (staikos@kde.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __DIMENSIONS_H
#define __DIMENSIONS_H
 
struct restab {
	int id;
	int w,h;
	const char * lname;
	const char * sname;
};
 
static struct restab cv_dimensions[] = {
	{ 0, 160, 120, "160 x 120 (1/4 NTSC)", "160 x 120" },
	{ 1, 192, 144, "192 x 144 (1/4 PAL)" , "192 x 144" },
	{ 2, 320, 240, "320 x 240 (1/2 NTSC)", "320 x 240" },
	{ 3, 384, 288, "384 x 288 (1/2 PAL)" , "384 x 288" },
	{ 4, 400, 300, "400 x 300 (default)" , "400 x 300" },
	{ 5, 640, 480, "640 x 480 (NTSC)"    , "640 x 480" },
	{ 6, 768, 576, "768 x 576 (PAL)"     , "768 x 576" },
	{ -1, 0,  5, NULL, NULL  }, /* do not change anything below */
	{ -1, 0,  5, NULL, NULL  },
	{ -1, 0,  5, NULL, NULL  }
};

#endif

