/*
 *    Copyright 2001, George Staikos <staikos@kde.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


// NOTE: most of this is unimplemented because it's not needed

#include "kde2dock.h"
#include <kapp.h>
#include <qtooltip.h>
#include <klocale.h>
#include <kiconloader.h>
#include <stdio.h>
#include <kpopupmenu.h>



KDE2DockWidget::KDE2DockWidget(QWidget * _master, const char *name)
  : KSystemTray(_master, name) {

  docked = false;
  master= _master;

  pos_x = pos_y = 0;

  setPixmap(BarIcon("kwintv_24x24"));
  contextMenu()->insertItem(i18n("&Channels..."), this, SLOT(channels()));
  contextMenu()->insertItem(i18n("&Fullscreen"), this, SLOT(fullScreen()));
  show();
}


KDE2DockWidget::~KDE2DockWidget() {
}


void KDE2DockWidget::channels() {
   emit channelsRequest();
}



void KDE2DockWidget::fullScreen() {
   emit fullScreenRequest();
}



void KDE2DockWidget::dock() {

  if (!docked) {
    // that's all the space there is
    setFixedSize(24, 24);

    // finally dock the widget
    show();
    docked = true;
  }
  
  if(master){
    QPoint point = master->mapToGlobal (QPoint (0,0));
    pos_x = point.x();
    pos_y = point.y();

  }
 
}

void KDE2DockWidget::undock() {
  if (docked) {
    docked = false;
  }
}

const bool KDE2DockWidget::isDocked() {
  return docked;
}


void KDE2DockWidget::toggle_window_state() {
}


void KDE2DockWidget::emit_quit()
{
}

void KDE2DockWidget::show() {
  KSystemTray::show();
}


void KDE2DockWidget::hide() {
  KSystemTray::hide();
}


#include "kde2dock.moc"

