/*
 *
 * Copyright (c) 2001, George Staikos <staikos@kde.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef _DOCKING2_H_
#define _DOCKING2_H_

#include <stdio.h>
#include <qwidget.h>
#include <ksystemtray.h>
#include <qpopupmenu.h>


class KDE2DockWidget : public KSystemTray {

  Q_OBJECT

public:
  KDE2DockWidget(QWidget *_master, const char *name=0);
  ~KDE2DockWidget();

public slots:
  virtual void hide();
  virtual void show();

private slots:
  void toggle_window_state();
  void fullScreen();
  void channels();

public slots:
  void dock();
  void undock();

public:
  const bool isDocked();

signals:
  void quit_clicked();
  void toggleDockMasterStateSIGNAL( bool );
  void fullScreenRequest();
  void channelsRequest();

private:
  bool docked;
  int toggleID;
  int pos_x;
  int pos_y;

  QWidget *master;

private slots:
  void emit_quit();
};

#endif

