#ifndef __KWinTVIface_h__
#define __KWinTVIface_h__
 
#include <qstringlist.h>
#include <dcopobject.h>
#include <dcopref.h>
 
class KWinTVIface : virtual public DCOPObject
{
    K_DCOP
public:
 
k_dcop:
    /**
     * Enter fullscreen mode.
     */
    virtual void fullScreen() = 0;

    /**
     * Leave fullscreen mode.
     */
    virtual void disableFullScreen() = 0;

    /**
     * Returns true if KWinTV is fullscreen
     */
    virtual bool isFullScreen() = 0;

    /**
     * Go up one channel.
     */
    virtual void channelUp() = 0;

    /**
     * Go down one channel.
     */
    virtual void channelDown() = 0;

    /**
     * Return to the previous channel.
     */
    virtual void channelPrevious() = 0;

    /**
     * Change the channel.
     */
    virtual void switchToChannel(int) = 0;

};
#endif

