/**********************************************************************

	--- Qt Architect generated file ---

	File: omixdev.cpp
	Last generated: Sat Jun 6 22:30:55 1998

 *********************************************************************/

#include <stdlib.h>
#include <wintv.h>
#include <kdebug.h>
#include "omixdev.h"

omixdev::omixdev ( const char * mdev,
		   int _can_grabber_audio,
		   QWidget* parent,
		   const char* name )
  : omixdevdata( parent, name ), can_grabber_audio(_can_grabber_audio)
{
  mix= new mixer();
  int devNr;
  const char *devName;
  c_idevice->clear();
  devName=mix->getFirstDeviceName(&devNr,true);
  if ( !devName )
     c_idevice->insertItem("<empty>");
  else while ( devName ) {
    c_idevice->insertItem(devName);
    devName=mix->getNextDeviceName(&devNr,true);
  }
  mixerslider->setRange( 0, MIXER_MAX_VALUE );
  rc=NULL;
}

omixdev::~omixdev()
{
  if ( rc )
    delete rc;
  delete mix;
}

void omixdev::setData(rcfile *_rc)
{

  if ( rc )
    delete rc;
  rc = new rcfile();

  rc->volume_right=_rc->volume_right;
  rc->use_tv_volume=_rc->use_tv_volume;
  rc->use_master_volume=_rc->use_master_volume;
  rc->mixerDevice=_rc->mixerDevice;
  rc->focusmute = _rc->focusmute;

  // get all the recording input devices
  int devNr,thisItem=0;
  aktive=-1;
  const char *devName;
  devName=mix->getFirstDeviceName(&devNr,true);
  while ( devName ) {
    if (devNr==rc->mixerDevice) aktive=thisItem;
    thisItem++;
    devName=mix->getNextDeviceName(&devNr,true);
  }

  // set the active input device
  if ((aktive != -1)) {
    c_idevice->setCurrentItem(aktive);
  } else {
    mix->getFirstDeviceName(&aktive,true);
    rc->mixerDevice=aktive;
    c_idevice->setCurrentItem(0);
    if ( mix->setRecSource(aktive,true) ) {
      mixerslider->setValue(rc->volume_right);
    }
  }

  mixerslider->setValue(rc->volume_right);

  if ( !can_grabber_audio ) {
    r_volgrabber->setEnabled(false);
    r_volgrabber->setChecked(false);
  } else r_volgrabber->setChecked(rc->use_tv_volume);

  r_mastervol->setChecked(!rc->use_master_volume);
  r_focusmute->setChecked( rc->focusmute );	// SH: added
}

void omixdev::mixDeviceSLOT(const QString& name)
{
  rc->mixerDevice=mix->name2Device(name);
  if ( rc->mixerDevice == NO_MDEV )
    kdWarning() << "omix: error setting new device " << name << " " << rc->mixerDevice << endl;
  mixerslider->setValue(mix->getVolume(VOL_LEFT));
}

void omixdev::volGrabberSLOT(bool on)
{
  rc->use_tv_volume=on;
  mixerslider->setEnabled(!on);
  r_mastervol->setEnabled(!on);
  c_idevice->setEnabled(!on);
}
void omixdev::newVolumeSLOT(int v)
{
  mix->setVolume(rc->mixerDevice,v,VOL_BOTH);
}
void omixdev::masterVolSLOT(bool on)
{
  rc->use_master_volume=!on;
}
void omixdev::sliderAttSLOT(bool on)
{
}
// SH: added slot
void omixdev::focusMuteSLOT( bool on ) {
	rc->focusmute = on;
}
#include "omixdev.moc"
