/**********************************************************************

	--- Qt Architect generated file ---

	File: osnapshot.cpp
	Last generated: Thu Jun 11 14:05:59 1998

 *********************************************************************/

#include <stdlib.h>
#include <wintv.h>
#include <qfiledlg.h>
#include <osnapshot.h>
#include "dimensions.h"
#include <kfiledialog.h>

#ifdef myDEBUG
#define ossDEBUG
#endif

struct pictab {
  int id;
  const char * lname;
  bool compress;
  int crl,crh,crdefault;
};

static struct pictab os_picformats[] = {
  { SNAPSHOT_PNM , "PNM", false, 0, 0, 0 },      /* libpnm, portable anymap */
#ifdef HAVE_LIBJPEG
  { SNAPSHOT_JPEG, "JPEG", true, 1, 100, 75 },
#endif
#ifdef HAVE_LIBTIFF
  { SNAPSHOT_TIFF, "TIFF", false, 0, 0, 0 },
#endif
#ifdef HAVE_LIBPNG
  { SNAPSHOT_PNG, "PNG", true, 0, 9, 6 },
#endif
  { -1, NULL, false, 0, 0, 0 }
};

osnapshot::osnapshot
(
	QWidget* parent,
	const char* name
)
	:
	osnapshotdata( parent, name )
{
  rc = 0L;
  int i=0;
  while ( cv_dimensions[i].id != -1 ) {
    thesize->insertItem(cv_dimensions[i].lname);
    i++;
  }

  i=0;
  while ( os_picformats[i].id != -1 ) {
    theimageformat->insertItem(os_picformats[i].lname);
    i++;
  }
}


osnapshot::~osnapshot()
{
  if ( rc )
    delete rc;
}

void osnapshot::setData(rcfile *_rc)
{

#ifdef ossDEBUG
  debug("oss: setData");
#endif
  if ( rc )
    delete rc;
  rc = new rcfile();

  rc->ss_quality=_rc->ss_quality;
  rc->ss_fixed=_rc->ss_fixed;
  rc->ss_width=_rc->ss_width;
  rc->ss_height=_rc->ss_height;
  rc->ss_format=_rc->ss_format;
  prefix = _rc->ss_prefix;
  imagename->setText(prefix);
  r_tvsize->setChecked(!rc->ss_fixed);
  r_fixedsize->setChecked(rc->ss_fixed);

  theimageformat->setCurrentItem(rc->ss_format);

  if ( !((rc->ss_quality >= os_picformats[rc->ss_format].crl) &&
       (rc->ss_quality <= os_picformats[rc->ss_format].crh)) ) {
    rc->ss_quality=os_picformats[rc->ss_format].crdefault;
  }
  thequality->setValue(rc->ss_quality);
  thequality->setEnabled(os_picformats[rc->ss_format].compress);

  int i=0;
  while ( cv_dimensions[i].id != -1 ) {
    if ( cv_dimensions[i].w == rc->ss_width ) {
      thesize->setCurrentItem(i);
      break;
    }
    i++;
  }

  thesize->setEnabled( rc->ss_fixed );
#ifdef ossDEBUG
  debug("oss: setData end");
#endif
}
void osnapshot::buttonSLOT(int id)
{
  rc->ss_fixed=id;
  thesize->setEnabled( id );
#ifdef ossDEBUG
  debug("oss: fixed snap shot %s",id?"on":"off");
#endif
}
void osnapshot::thesizeSLOT(int id)
{
  rc->ss_width=cv_dimensions[id].w;
  rc->ss_height=cv_dimensions[id].h;
}

void osnapshot::imagenameSLOT(const QString& name)
{
  prefix = name;
}

void osnapshot::imageformatSLOT(int id)
{
  rc->ss_format= id;

  rc->ss_quality=os_picformats[rc->ss_format].crdefault;
  thequality->setValue(rc->ss_quality);
  thequality->setEnabled(os_picformats[rc->ss_format].compress);
}

void osnapshot::browseSLOT()
{
  QString fileName =
    KFileDialog::getExistingDirectory(prefix);
  if ( !fileName.isNull() ) {                 // got a file name
    fileName+="/";
    imagename->setText(fileName);
  }
}
void osnapshot::newQualitySLOT(int val)
{
  rc->ss_quality= val;
}
//  do not edit
#include "osnapshot.moc"




