/**********************************************************************

	--- Qt Architect generated file ---

	File: wizScan.cpp
	Last generated: Sat Aug 26 20:12:46 2000

 *********************************************************************/

#include <unistd.h>

#include "wizScan.h"
#include "wintvscreen.h"

#include <klocale.h>

#define MIN_COUNT 10

wizScan::wizScan
(
	QWidget* parent,
	const char* name
)
	:
	wizScanData( parent, name )
{
  wizLLCFound->setText("0");
  wizPBProgress->reset();

  minfreq = 0;
  maxfreq = 0x7fff;
  scanstate = ScanSetup;
  sigquality = (int)(65535.0*((double)SIGQUALITY/100.0));

  screen->rawCapTunerRange(&minfreq,&maxfreq);

  if ( minfreq == 0x8e ) minfreq = 640; // 40MHz
  if ( maxfreq == 0x7fff ) maxfreq /= 2;

  frange = maxfreq - minfreq;

  wizLCDFreq->display(QString::number(minfreq/16.0,'f',2));

  wizPBStop->setEnabled(false);
}


wizScan::~wizScan()
{
}

void wizScan::setScanInfo(ChannelList * _list, int _norm, int _region, bool _all)
{
  scanstate = ScanSetup;

  list  = _list;
  norm   = _norm;
  region = _region;
  all    = _all;

  lcountry.change(region);

  if ( all )
    frange = maxfreq - minfreq;
  else
    frange = lcountry.nftab();

  screen->rawSetChannel( 0 );
  screen->rawSetChannelNorm( norm );
  wizLCDFreq->display(QString::number(minfreq/16.0,'f',2));

  wizPBStart->setEnabled(true);
  wizPBStop->setEnabled(false);
  wizPBStart->setText(i18n("Start"));
  wizLLCFound->setText("0");
  wizPBProgress->reset();
}

void wizScan::wizPBStartSLOT()
{
  if ( scanstate == ScanContinue ) {
    wizPBStart->setEnabled(false);
    wizPBStop->setEnabled(true);
    scanstate = ScanInProgress;

    if ( all ) {
      scanfval = 2;
      slost1 = true;
      sfound = false;
      slost2 = false;
      frequency = flost;
      ffound = frequency;
    } else {
      frequency=nfrequency;
    }
  }

  if ( scanstate == ScanAbort ) {
    scanstate = ScanContinueAfterAbort;
    wizPBStart->setEnabled(true);
    wizPBStop->setEnabled(false);
    wizPBStart->setText(i18n("Continue"));
  }

  if ( scanstate == ScanSetup ) {
    list->clear();
    wizPBProgress->reset();
    wizPBStart->setEnabled(false);
    wizPBStop->setEnabled(true);

    scanstate = ScanInProgress;

    ccount = 0;
    scanfval = 5;
    slost1 = (screen->rawGetTunerSignal() < sigquality);
    sfound = false;
    slost2 = false;
    if ( all ) {
      frequency = minfreq;
    } else {
      frequency = lcountry.firstchan(cname);
      fstfrequency = frequency;
    }
    ffound = frequency;
    flost = frequency;
    screen->rawSetFreq(frequency);
  }

  if ( scanstate == ScanInProgress ) {
    if ( all ) {
      frequency += scanfval;
      wizLCDFreq->display(QString::number(frequency/16.0,'f',2));
      wizPBProgress->setProgress((frequency-minfreq)*100/frange);
      if ( frequency > maxfreq ) {
	scanstate = ScanDone;
	wizPBStop->setEnabled(false);
	emit wizScanScanReadySIGNAL();
      } else {
	screen->rawSetFreq(frequency);
	QTimer::singleShot( SCAN_DELAY , this, SLOT(wizAutoScanSLOT()) );
      }
    } else {
      nfrequency = lcountry.nextchan(cname);
      wizPBProgress->setProgress(lcountry.activeindex()*100/frange);
      wizLCDFreq->display(QString::number(frequency/16.0,'f',2));
      if ( nfrequency == fstfrequency ) {
	scanstate = ScanDone;
	wizPBStop->setEnabled(false);
	emit wizScanScanReadySIGNAL();
      } else {
	screen->rawSetFreq(frequency);
	QTimer::singleShot( SCAN_DELAY * 4, this, SLOT(wizAutoScanSLOT()) );

      }
    }
  }

  if ( scanstate == ScanContinueAfterAbort ) {
    scanstate = ScanContinue;
  }

}
void wizScan::wizPBStopSLOT()
{
  scanstate = ScanAbort;
  emit wizScanScanReadySIGNAL();
}

void wizScan::wizAutoScanSLOT()
{
  if (scanstate == ScanAbort) {
    wizPBStartSLOT();
    return;
  }

  int quality = screen->rawGetTunerSignal();

  if ( !all ) {
    if ( quality >= sigquality ) {
      nchannel = new channel(frequency,
			     QString("channel ").append(cname).latin1(),
			     DCOL,DHUE,DBRI,DCONTRAST,
			     norm,
			     0, /* input = Tuner */
			     region,
			     cname /* channel id */);

      wizLLCFound->setText(QString::number(++ccount));
      list->append(nchannel);
    }

    if (scanstate != ScanAbort) scanstate = ScanContinue;
    wizPBStartSLOT();

  } else {
    // scan all frequencies
    if ( !slost2 ) {

      if ( !slost1 ) {
	slost1 = quality < sigquality;
	if ( slost1 ) scanfval = 2; // was 2
      } else if ( !sfound ) {
	sfound = quality > sigquality;
	if ( sfound ) {
	  ffound = frequency;
	  smaxsig = quality;
	  fmaxsig = frequency;
	  scanfval = 1;
	  sfcount = 0;
	}
      } else if ( !slost2 ) {
	if ( smaxsig < quality ) {
	  smaxsig = quality;
	  fmaxsig = frequency;
	}
	sfcount++;
	slost2 = quality < sigquality;
	if ( slost2 ) {
	  flost = frequency - 1;
	  if ( sfcount < MIN_COUNT ) {
	    slost2=false;
	    sfound=false;
	  }
	}
      }

      wizPBStartSLOT();

    } else {
      if  ( slost1 && slost2 && sfound ) {
	if ( fmaxsig == ffound && smaxsig == 0xffff ) { // fake signal quality
	  frequency = 1 + (flost + ffound) / 2;
	} else {
	  frequency = fmaxsig;
	}
	screen->rawSetFreq(frequency);
      }

      nchannel = new channel(frequency,
			     QString::number(frequency/16.0,'f',4).latin1(),
			     DCOL,DHUE,DBRI,DCONTRAST,
			     norm,
			     0, /* input = Tuner */
			     region,
			     cname /* channel id */);

      wizLLCFound->setText(QString::number(++ccount));
      list->append(nchannel);

      scanfval = 2;
      if (scanstate != ScanAbort) scanstate = ScanContinue;
      wizPBStartSLOT();

    }
  }
}
//-------------------------------------------------------------------
//-------------------------------------------------------------------
#include "wizScan.moc"






