/* 
    Copyright (C) 2001 George Staikos (staikos@kde.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef _XHELPERS_H
#define _XHELPERS_H

/*    Return the screen number that point (x,y) is in, or return 0
 *    if it's not in any or Xinerama not present
 */
int XineramaGetScreenForPoint(int x, int y);


/*    Get the screen geometry using Xinerama if available, else using
 *    traditional methods.
 */
void XineramaGetScreenGeometry(int screen, int *x, int *y, int *w, int *h);


/*    Return the screen number of the screen left of "screen".
 *    Returns -1 if none.
 */
int XineramaLeftOf(int screen);

/*    Return the screen number of the screen right of "screen".
 *    Returns -1 if none.
 */
int XineramaRightOf(int screen);

/*    Return the screen number of the screen above "screen".
 *    Returns -1 if none.
 */
int XineramaAbove(int screen);

/*    Return the screen number of the screen below "screen".
 *    Returns -1 if none.
 */
int XineramaBelow(int screen);

#endif

