/*
    KWinTV ScreenSaver

    Copyright (C) 2001 George Staikos (staikos@kde.org)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __WINTVSAVER_H__
#define __WINTVSAVER_H__

#include <qdialog.h>
#include <qcolor.h>
#include <kscreensaver.h>
#include <dcopclient.h>

class KColorButton;


class KWinTVSaver : public KScreenSaver
{
	Q_OBJECT
public:
	KWinTVSaver( WId drawable );
	virtual ~KWinTVSaver();

	void setColor( const QColor &col );

private:
	void readSettings();
	void blank();

private:
	QColor color;
	DCOPClient *dcc;
};


class KWinTVSetup : public QDialog
{
	Q_OBJECT
public:
	KWinTVSetup( QWidget *parent = NULL, const char *name = NULL );

protected:
	void readSettings();

private slots:
	void slotColor( const QColor & );
	void slotOkPressed();

private:
	QWidget *preview;
	KWinTVSaver *saver;
	KColorButton *colorPush;

	QColor color;
};

#endif

